function _typeof(obj) {
  '@babel/helpers - typeof';

  if (typeof Symbol === 'function' && typeof Symbol.iterator === 'symbol') {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj &&
        typeof Symbol === 'function' &&
        obj.constructor === Symbol &&
        obj !== Symbol.prototype
        ? 'symbol'
        : typeof obj;
    };
  }
  return _typeof(obj);
}

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.CounterMeter = void 0;

const _react = _interopRequireDefault(require('react'));

const _propTypes = _interopRequireDefault(require('prop-types'));

const R = _interopRequireWildcard(require('ramda'));

const _core = require('@material-ui/core');

const _Caption = require('./Caption');

const _uiUtils = require('../ui-utils');

function _getRequireWildcardCache() {
  if (typeof WeakMap !== 'function') return null;
  const cache = new WeakMap();
  _getRequireWildcardCache = function _getRequireWildcardCache() {
    return cache;
  };
  return cache;
}

function _interopRequireWildcard(obj) {
  if (obj && obj.__esModule) {
    return obj;
  }
  if (obj === null || (_typeof(obj) !== 'object' && typeof obj !== 'function')) {
    return { default: obj };
  }
  const cache = _getRequireWildcardCache();
  if (cache && cache.has(obj)) {
    return cache.get(obj);
  }
  const newObj = {};
  const hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (const key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) {
      const desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc);
      } else {
        newObj[key] = obj[key];
      }
    }
  }
  newObj.default = obj;
  if (cache) {
    cache.set(obj, newObj);
  }
  return newObj;
}

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

// import Typography from '@material-ui/core/Typography';

/**
 *
 * DEPRECATED.
 *
 * HERE FOR BACKWARD COMPATIBILITY
 *
 * USE NEW ValueDisplay
 *
 */
const useStyles = (0, _core.makeStyles)(function () {
  return {
    flexContainer: {
      display: 'flex',
      position: 'relative',
      flexDirection: 'column',
      alignItems: 'center',
      justifyContent: 'center',
    },
    // bg: {
    //   position: 'absolute',
    //   width: '100%',
    //   height: '100%',
    //   zIndex: -1,
    // },
    box: {
      textAlign: 'center',
    },
  };
});

function textStyleFromText(str, size) {
  const fontSize = Math.max(16, 90 - str.length * 4 - size * 11);
  return {
    fontSize,
  };
}

const propTypes = {
  width: _propTypes.default.number,
  height: _propTypes.default.number,
  values: _propTypes.default.arrayOf(
    _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  ),
  config: _propTypes.default.arrayOf(_propTypes.default.any), // bgOffset: PropTypes.number,
};
const defaultProps = {
  width: 300,
  height: undefined,
  values: [],
  config: [], // bgOffset: 230,
};

const CounterMeterC = function CounterMeterC(_ref) {
  const { width } = _ref;
  const { height } = _ref;
  const { config } = _ref;
  const { values } = _ref;
  // TODO: Add "point" as prop and handle both "data age"/ts and
  // more than 4 values (render as scrollable table/list (perhaps use Table?!))
  const classes = useStyles(); // console.log('values:', values);

  return /* #__PURE__ */ _react.default.createElement(
    'div',
    {
      style: {
        width,
        height,
      },
      className: classes.flexContainer,
    },
    values.map(function (v, i) {
      let value = v;

      const _ref2 = config[i] || {};
      const _ref2$unit = _ref2.unit;
      const unit = _ref2$unit === void 0 ? '' : _ref2$unit;
      const { transform } = _ref2;
      const { decimals } = _ref2;
      const toFloor = _ref2.floor;
      const { label } = _ref2;
      const { precision } = _ref2;
      const { ltOnePrecision } = _ref2;

      const prettifyValue = R.memoizeWith(
        function () {
          return JSON.stringify([precision, decimals, toFloor, ltOnePrecision]);
        },
        (0, _uiUtils.prettifyNumberWithOptions)({
          precision,
          decimals,
          toFloor,
          ltOnePrecision,
        }),
      );

      if (config[i]) {
        if (transform) {
          if (typeof transform === 'function')
            try {
              value = config[i].transform(value);
            } catch (err) {
              console.warn(
                'CounterMeter - config[x].transform failed. Value:',
                value,
                'Transform:',
                transform,
              );
            }
          else
            console.warn(
              'CounterMeter - config[x].transform not of type function. transform is:',
              transform,
            );
        }
      }

      value = prettifyValue(value);
      value = R.isNil(value) ? '-' : value;
      return /* #__PURE__ */ _react.default.createElement(
        'div',
        {
          key: label || i,
          className: classes.box,
          style: {
            marginBottom: Math.max(10, 30 - values.length * 8),
          },
        },
        /* #__PURE__ */ _react.default.createElement(
          'span',
          {
            style:
              values.length >= 4
                ? {
                    fontSize: 16,
                  }
                : textStyleFromText(''.concat(value).concat(unit), values.length),
          },
          R.isNil(value) || Number.isNaN(value) ? '-' : ''.concat(value).concat(unit),
        ),
        /* #__PURE__ */ _react.default.createElement('br', null),
        /* #__PURE__ */ _react.default.createElement(_Caption.Caption, {
          label: label || /* #__PURE__ */ _react.default.createElement('span', null, '\xA0'),
        }),
      );
    }),
  );
};

CounterMeterC.propTypes = propTypes;
CounterMeterC.defaultProps = defaultProps;
const CounterMeter = CounterMeterC;
exports.CounterMeter = CounterMeter;
