"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FlexIcon = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _core = require("@material-ui/core");

require("mdi/css/materialdesignicons.min.css");

var _Icon = _interopRequireDefault(require("@material-ui/core/Icon"));

var _dataUtils = require("../data-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// import { between } from '../transforms';
var paletteGetters = {
  secondary: function secondary(pal) {
    var _pal$secondary;

    return pal === null || pal === void 0 ? void 0 : (_pal$secondary = pal.secondary) === null || _pal$secondary === void 0 ? void 0 : _pal$secondary.main;
  },
  primary: function primary(pal) {
    var _pal$primary;

    return pal === null || pal === void 0 ? void 0 : (_pal$primary = pal.primary) === null || _pal$primary === void 0 ? void 0 : _pal$primary.main;
  },
  action: function action(pal) {
    var _pal$action;

    return pal === null || pal === void 0 ? void 0 : (_pal$action = pal.action) === null || _pal$action === void 0 ? void 0 : _pal$action.active;
  },
  disabled: function disabled(pal) {
    var _pal$action2;

    return pal === null || pal === void 0 ? void 0 : (_pal$action2 = pal.action) === null || _pal$action2 === void 0 ? void 0 : _pal$action2.disabled;
  },
  none: function none(pal) {
    var _pal$action3;

    return pal === null || pal === void 0 ? void 0 : (_pal$action3 = pal.action) === null || _pal$action3 === void 0 ? void 0 : _pal$action3.disabled;
  },
  info: function info(pal) {
    var _pal$info$main, _pal$info, _pal$action4;

    return (_pal$info$main = pal === null || pal === void 0 ? void 0 : (_pal$info = pal.info) === null || _pal$info === void 0 ? void 0 : _pal$info.main) !== null && _pal$info$main !== void 0 ? _pal$info$main : pal === null || pal === void 0 ? void 0 : (_pal$action4 = pal.action) === null || _pal$action4 === void 0 ? void 0 : _pal$action4.active;
  },
  minor: function minor(pal) {
    var _pal$info$main2, _pal$info2, _pal$action5;

    return (_pal$info$main2 = pal === null || pal === void 0 ? void 0 : (_pal$info2 = pal.info) === null || _pal$info2 === void 0 ? void 0 : _pal$info2.main) !== null && _pal$info$main2 !== void 0 ? _pal$info$main2 : pal === null || pal === void 0 ? void 0 : (_pal$action5 = pal.action) === null || _pal$action5 === void 0 ? void 0 : _pal$action5.active;
  },
  error: function error(pal) {
    var _pal$error;

    return pal === null || pal === void 0 ? void 0 : (_pal$error = pal.error) === null || _pal$error === void 0 ? void 0 : _pal$error.main;
  },
  critical: function critical(pal) {
    var _pal$error2;

    return pal === null || pal === void 0 ? void 0 : (_pal$error2 = pal.error) === null || _pal$error2 === void 0 ? void 0 : _pal$error2.main;
  },
  warning: function warning(pal) {
    var _pal$warning;

    return pal === null || pal === void 0 ? void 0 : (_pal$warning = pal.warning) === null || _pal$warning === void 0 ? void 0 : _pal$warning.main;
  },
  major: function major(pal) {
    var _pal$warning2;

    return pal === null || pal === void 0 ? void 0 : (_pal$warning2 = pal.warning) === null || _pal$warning2 === void 0 ? void 0 : _pal$warning2.main;
  },
  success: function success(pal) {
    var _pal$success$main, _pal$success, _pal$action6;

    return (_pal$success$main = pal === null || pal === void 0 ? void 0 : (_pal$success = pal.success) === null || _pal$success === void 0 ? void 0 : _pal$success.main) !== null && _pal$success$main !== void 0 ? _pal$success$main : pal === null || pal === void 0 ? void 0 : (_pal$action6 = pal.action) === null || _pal$action6 === void 0 ? void 0 : _pal$action6.active;
  }
};

var stringToThemeColor = function stringToThemeColor(str) {
  var _paletteGetters$str;

  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$palette = _ref.palette,
      palette = _ref$palette === void 0 ? {} : _ref$palette;

  return ((_paletteGetters$str = paletteGetters[str]) !== null && _paletteGetters$str !== void 0 ? _paletteGetters$str : paletteGetters.action)(palette);
}; // const stringToIconColorId = str => {
//   if (['inherit', 'primary', 'secondary', 'action', 'error', 'disabled'].includes(str)) return str;
//   if (str === 'none') return 'disabled';
//   if (str === 'warning') return 'secondary';
//   if (str === 'critical') return 'error';
//   if (str === 'info') return 'action';
//   if (str === 'minor') return 'action';
//   if (str === 'major') return 'error';
//   if (str === 'success') return 'primary';
//   return 'inherit';
// };
// const clampIconSize = R.cond([
//   [between(0, 21), R.always(18)],
//   [between(21, 30), R.always(24)],
//   [between(30, 42), R.always(36)],
//   [between(42, 100000), R.always(48)],
// ]);


var sizeToNumber = {
  sm: 18,
  md: 24,
  lg: 36,
  xl: 48
};

var sizeToNum = function sizeToNum(size) {
  var _sizeToNumber$size;

  return typeof size === 'string' ? (_sizeToNumber$size = sizeToNumber[size]) !== null && _sizeToNumber$size !== void 0 ? _sizeToNumber$size : sizeToNumber.xl : size;
};

var propTypes = {
  children: _propTypes["default"].node,
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  icon: _propTypes["default"].string,
  className: _propTypes["default"].string,
  size: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  color: _propTypes["default"].string // inherit, secondary, primary, action, disabled or error

};
var useStyles = (0, _core.makeStyles)(function () {
  return {
    mdicon: {
      '&::before': {
        fontSize: 'inherit !important'
      }
    }
  };
});

var FlexIcon = function FlexIcon(_ref2) {
  var _ref3;

  var icon = _ref2.icon,
      _ref2$style = _ref2.style,
      style = _ref2$style === void 0 ? _dataUtils.emptyObj : _ref2$style,
      color = _ref2.color,
      _ref2$size = _ref2.size,
      size = _ref2$size === void 0 ? 24 : _ref2$size,
      children = _ref2.children,
      className = _ref2.className;
  var classes = useStyles();
  var theme = (0, _core.useTheme)(); // console.log({ icon, children, color });

  var iconStr = ((_ref3 = children || icon) !== null && _ref3 !== void 0 ? _ref3 : '').trim();
  var mdi = iconStr.startsWith('mdi-');
  var sizeNumber = sizeToNum(size);
  var isColorCode = color && color.startsWith && (color.startsWith('#') || color.startsWith('rgb'));
  var commonStyle = {
    fontSize: "".concat(sizeNumber, "px"),
    color: isColorCode ? color : stringToThemeColor(color, theme)
  };

  if (mdi) {
    var _classnames;

    return /*#__PURE__*/_react["default"].createElement("i", {
      style: _objectSpread({}, commonStyle, {
        lineHeight: "".concat(sizeNumber, "px"),
        fontSize: "".concat(sizeNumber, "px"),
        height: sizeNumber,
        width: sizeNumber
      }, style),
      className: (0, _classnames2["default"])((_classnames = {
        mdi: true,
        'mdi-48px': true
      }, _defineProperty(_classnames, iconStr, true), _defineProperty(_classnames, className, !!className), _defineProperty(_classnames, classes.mdicon, true), _classnames))
    });
  }

  return /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
    style: commonStyle,
    className: className
  }, iconStr);
};

exports.FlexIcon = FlexIcon;
FlexIcon.propTypes = propTypes;