"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Indicator = exports.okColor = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames4 = _interopRequireDefault(require("classnames"));

var R = _interopRequireWildcard(require("ramda"));

var _CircularProgress = _interopRequireDefault(require("@material-ui/core/CircularProgress"));

var _core = require("@material-ui/core");

var _FlexIcon = require("./FlexIcon");

var _dataUtils = require("../data-utils");

var _useLoadingTimeout = require("../hooks/useLoadingTimeout");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var okColor = '#00dd80';
exports.okColor = okColor;
var useStyles = (0, _core.makeStyles)(function () {
  return {
    alarm: {
      animation: '$shake .2s linear infinite'
    },
    '@keyframes shake': {
      '0%': {
        transform: 'rotate(-5deg)'
      },
      '50%': {
        transform: 'rotate(3deg)'
      }
    }
  };
});
var propTypes = {
  signal: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].number]),
  size: _propTypes["default"].number,
  animatedErr: _propTypes["default"].bool,
  className: _propTypes["default"].string,
  okIconId: _propTypes["default"].string,
  errIconId: _propTypes["default"].string,
  unknownIconId: _propTypes["default"].string,
  timeout: _propTypes["default"].number,
  iconStyle: _propTypes["default"].objectOf(_propTypes["default"].any)
};

var Indicator = _react["default"].memo(function (_ref) {
  var _classnames2;

  var signal = _ref.signal,
      _ref$iconStyle = _ref.iconStyle,
      iconStyle = _ref$iconStyle === void 0 ? _dataUtils.emptyObj : _ref$iconStyle,
      _ref$animatedErr = _ref.animatedErr,
      animatedErr = _ref$animatedErr === void 0 ? false : _ref$animatedErr,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 56 : _ref$size,
      _ref$okIconId = _ref.okIconId,
      okIconId = _ref$okIconId === void 0 ? 'check' : _ref$okIconId,
      _ref$errIconId = _ref.errIconId,
      errIconId = _ref$errIconId === void 0 ? 'warning' : _ref$errIconId,
      _ref$unknownIconId = _ref.unknownIconId,
      unknownIconId = _ref$unknownIconId === void 0 ? 'block' : _ref$unknownIconId,
      className = _ref.className,
      _ref$timeout = _ref.timeout,
      timeout = _ref$timeout === void 0 ? 10 : _ref$timeout;
  var classes = useStyles();
  var loading = (0, _useLoadingTimeout.useLoadingTimeout)(timeout);

  if (R.isNil(signal)) {
    if (loading) return /*#__PURE__*/_react["default"].createElement(_CircularProgress["default"], {
      size: size
    });
    return /*#__PURE__*/_react["default"].createElement(_FlexIcon.FlexIcon, {
      className: (0, _classnames4["default"])(_defineProperty({}, className, !!className)),
      color: "disabled",
      size: size,
      style: iconStyle
    }, unknownIconId);
  }

  return !signal ? /*#__PURE__*/_react["default"].createElement(_FlexIcon.FlexIcon, {
    className: (0, _classnames4["default"])((_classnames2 = {}, _defineProperty(_classnames2, classes.alarm, animatedErr), _defineProperty(_classnames2, className, !!className), _classnames2)),
    color: "error",
    size: size,
    style: iconStyle
  }, errIconId) : /*#__PURE__*/_react["default"].createElement(_FlexIcon.FlexIcon, {
    className: (0, _classnames4["default"])(_defineProperty({}, className, !!className)),
    color: okColor,
    size: size,
    style: iconStyle
  }, okIconId);
});

exports.Indicator = Indicator;
Indicator.propTypes = propTypes;