"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MessageList = exports.MessageListItem = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var R = _interopRequireWildcard(require("ramda"));

var _fp = require("date-fns/fp");

var _core = require("@material-ui/core");

var _Collapse = _interopRequireDefault(require("@material-ui/core/Collapse"));

var _List = _interopRequireDefault(require("@material-ui/core/List"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _ListItemAvatar = _interopRequireDefault(require("@material-ui/core/ListItemAvatar"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _FlexIcon = require("./FlexIcon");

var _Caption = require("./Caption");

var _dmUtils = require("../dm-utils");

var _transforms = require("../transforms");

var _useUpdateTrigger = require("../hooks/useUpdateTrigger");

var _dataUtils = require("../data-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useStyles = (0, _core.makeStyles)(function () {
  return {
    wrapper: {
      overflowY: 'auto',
      overflowX: 'hidden',
      height: '100%',
      width: '100%',
      paddingTop: 0
    } // icon: { alignSelf: 'center', paddingRight: theme.spacing(2) },
    // text: { paddingLeft: 12 },
    // inline: {
    //   display: 'inline',
    // },

  };
});
var propTypes = {
  points: _propTypes["default"].arrayOf(_propTypes["default"].any),
  point: _propTypes["default"].objectOf(_propTypes["default"].any),
  style: _propTypes["default"].objectOf(_propTypes["default"].any)
};

var MessageListItem = _react["default"].memo(function (_ref) {
  var _severityMap$severity;

  var point = _ref.point;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      expanded = _useState2[0],
      setExpanded = _useState2[1]; // const classes = useStyles();


  (0, _react.useEffect)(function () {
    setTimeout(function () {
      return setExpanded(true);
    }, 10);
  }, []);
  (0, _useUpdateTrigger.useUpdateTrigger)({
    restartTrigger: point.ts
  });

  var _useMemo = (0, _react.useMemo)(function () {
    return (0, _dmUtils.messageAsNotification)(point);
  }, [point]),
      _useMemo2 = _slicedToArray(_useMemo, 4),
      ts = _useMemo2[0],
      severity = _useMemo2[1],
      title = _useMemo2[2],
      text = _useMemo2[3]; // const { signal = 'Unknown', severity = 'none' } = pl[0];
  // const iConf = severityMap[severity] || severityMap.none;


  return /*#__PURE__*/_react["default"].createElement(_Collapse["default"], {
    "in": expanded
  }, /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
    alignItems: "flex-start"
  }, /*#__PURE__*/_react["default"].createElement(_ListItemAvatar["default"], null, /*#__PURE__*/_react["default"].createElement(_FlexIcon.FlexIcon, {
    icon: (_severityMap$severity = _dmUtils.severityMap[severity]) === null || _severityMap$severity === void 0 ? void 0 : _severityMap$severity.icon,
    color: severity
  })), /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
    primary: /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
      variant: "subtitle1"
    }, title),
    secondary: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
      variant: "body1",
      color: "textPrimary"
    }, text), /*#__PURE__*/_react["default"].createElement(_Caption.Caption, {
      label: (0, _fp.formatDistance)(new Date(), ts)
    }))
  })), /*#__PURE__*/_react["default"].createElement(_Divider["default"], {
    component: "li"
  }));
});

exports.MessageListItem = MessageListItem;
MessageListItem.propTypes = {
  point: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired
};

var MessageList = function MessageList(_ref2) {
  var style = _ref2.style,
      _ref2$points = _ref2.points,
      points = _ref2$points === void 0 ? _dataUtils.emptyArr : _ref2$points,
      point = _ref2.point;
  var classes = useStyles();

  var _useState3 = (0, _react.useState)(points),
      _useState4 = _slicedToArray(_useState3, 2),
      msgs = _useState4[0],
      setMsgs = _useState4[1];

  (0, _react.useEffect)(function () {
    if ((0, _transforms.nilOrEmpty)(points)) return;
    setMsgs(points);
  }, [points]);
  (0, _react.useEffect)(function () {
    if ((0, _transforms.nilOrEmpty)(point)) return;
    setMsgs(function (prevMsgs) {
      return [].concat(_toConsumableArray(prevMsgs), [point]);
    });
  }, [point]); // console.log('MessageList', points);
  // <Box css={style} className={classes.wrapper}>

  return /*#__PURE__*/_react["default"].createElement(_List["default"], {
    className: classes.wrapper,
    style: style
  }, /*#__PURE__*/_react["default"].createElement(_Divider["default"], {
    component: "li"
  }), R.compose(R.map(function (msg) {
    return /*#__PURE__*/_react["default"].createElement(MessageListItem, {
      point: msg,
      key: JSON.stringify(msg)
    });
  }), R.reverse, R.when(function (m) {
    return !Array.isArray(m);
  }, R.of))(msgs));
};

exports.MessageList = MessageList;
MessageList.propTypes = propTypes;