"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PagePadding = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _styles = require("@material-ui/core/styles");

var _dataUtils = require("../data-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    paddingT: _defineProperty({
      paddingTop: theme.spacing(2)
    }, theme.breakpoints.up('sm'), {
      paddingTop: theme.spacing(3)
    }),
    paddingB: {
      paddingBottom: 100
    },
    paddingH: _defineProperty({
      paddingLeft: theme.spacing(1),
      paddingRight: theme.spacing(1)
    }, theme.breakpoints.up('sm'), {
      paddingLeft: theme.spacing(3),
      paddingRight: theme.spacing(3)
    })
  };
});
var propTypes = {
  children: _propTypes["default"].node.isRequired,
  noHoriz: _propTypes["default"].bool,
  noBot: _propTypes["default"].bool,
  noTop: _propTypes["default"].bool,
  className: _propTypes["default"].string,
  style: _propTypes["default"].objectOf(_propTypes["default"].any)
};

var PagePadding = function PagePadding(_ref) {
  var _classnames;

  var _ref$noHoriz = _ref.noHoriz,
      noHoriz = _ref$noHoriz === void 0 ? false : _ref$noHoriz,
      _ref$noBot = _ref.noBot,
      noBot = _ref$noBot === void 0 ? false : _ref$noBot,
      _ref$noTop = _ref.noTop,
      noTop = _ref$noTop === void 0 ? false : _ref$noTop,
      children = _ref.children,
      _ref$style = _ref.style,
      style = _ref$style === void 0 ? _dataUtils.emptyObj : _ref$style,
      className = _ref.className;
  var classes = useStyles();
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames2["default"])((_classnames = {}, _defineProperty(_classnames, className, !!className), _defineProperty(_classnames, classes.paddingT, !noTop), _defineProperty(_classnames, classes.paddingB, !noBot), _defineProperty(_classnames, classes.paddingH, !noHoriz), _classnames)),
    style: style
  }, children);
};

exports.PagePadding = PagePadding;
PagePadding.propTypes = propTypes;