function _typeof(obj) {
  '@babel/helpers - typeof';

  if (typeof Symbol === 'function' && typeof Symbol.iterator === 'symbol') {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj &&
        typeof Symbol === 'function' &&
        obj.constructor === Symbol &&
        obj !== Symbol.prototype
        ? 'symbol'
        : typeof obj;
    };
  }
  return _typeof(obj);
}

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.PointList = exports.PointListItem = void 0;

const _react = _interopRequireWildcard(require('react'));

const _propTypes = _interopRequireDefault(require('prop-types'));

const R = _interopRequireWildcard(require('ramda'));

const _fp = require('date-fns/fp');

const _core = require('@material-ui/core');

const _Collapse = _interopRequireDefault(require('@material-ui/core/Collapse'));

const _List = _interopRequireDefault(require('@material-ui/core/List'));

const _ListItem = _interopRequireDefault(require('@material-ui/core/ListItem'));

const _Divider = _interopRequireDefault(require('@material-ui/core/Divider'));

const _ListItemText = _interopRequireDefault(require('@material-ui/core/ListItemText'));

const _ListItemAvatar = _interopRequireDefault(require('@material-ui/core/ListItemAvatar'));

const _Typography = _interopRequireDefault(require('@material-ui/core/Typography'));

const _FlexIcon = require('./FlexIcon');

const _Caption = require('./Caption');

const _dmUtils = require('../dm-utils');

const _transforms = require('../transforms');

const _uiUtils = require('../ui-utils');

const _useUpdateTrigger = require('../hooks/useUpdateTrigger');

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

function _getRequireWildcardCache() {
  if (typeof WeakMap !== 'function') return null;
  const cache = new WeakMap();
  _getRequireWildcardCache = function _getRequireWildcardCache() {
    return cache;
  };
  return cache;
}

function _interopRequireWildcard(obj) {
  if (obj && obj.__esModule) {
    return obj;
  }
  if (obj === null || (_typeof(obj) !== 'object' && typeof obj !== 'function')) {
    return { default: obj };
  }
  const cache = _getRequireWildcardCache();
  if (cache && cache.has(obj)) {
    return cache.get(obj);
  }
  const newObj = {};
  const hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (const key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) {
      const desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc);
      } else {
        newObj[key] = obj[key];
      }
    }
  }
  newObj.default = obj;
  if (cache) {
    cache.set(obj, newObj);
  }
  return newObj;
}

function _toArray(arr) {
  return (
    _arrayWithHoles(arr) ||
    _iterableToArray(arr) ||
    _unsupportedIterableToArray(arr) ||
    _nonIterableRest()
  );
}

function _toConsumableArray(arr) {
  return (
    _arrayWithoutHoles(arr) ||
    _iterableToArray(arr) ||
    _unsupportedIterableToArray(arr) ||
    _nonIterableSpread()
  );
}

function _nonIterableSpread() {
  throw new TypeError(
    'Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.',
  );
}

function _iterableToArray(iter) {
  if (typeof Symbol !== 'undefined' && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _slicedToArray(arr, i) {
  return (
    _arrayWithHoles(arr) ||
    _iterableToArrayLimit(arr, i) ||
    _unsupportedIterableToArray(arr, i) ||
    _nonIterableRest()
  );
}

function _nonIterableRest() {
  throw new TypeError(
    'Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.',
  );
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === 'string') return _arrayLikeToArray(o, minLen);
  let n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === 'Object' && o.constructor) n = o.constructor.name;
  if (n === 'Map' || n === 'Set') return Array.from(n);
  if (n === 'Arguments' || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }
  return arr2;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === 'undefined' || !(Symbol.iterator in Object(arr))) return;
  const _arr = [];
  let _n = true;
  let _d = false;
  let _e;
  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);
      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i.return != null) _i.return();
    } finally {
      if (_d) throw _e;
    }
  }
  return _arr;
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

const useStyles = (0, _core.makeStyles)(function () {
  return {
    wrapper: {
      overflowY: 'auto',
      overflowX: 'hidden',
      height: '100%',
      width: '100%',
      paddingTop: 0,
    }, // icon: { alignSelf: 'center', paddingRight: theme.spacing(2) },
    // text: { paddingLeft: 12 },
    // inline: {
    //   display: 'inline',
    // },
  };
});
const propTypes = {
  points: _propTypes.default.arrayOf(_propTypes.default.any),
  point: _propTypes.default.objectOf(_propTypes.default.any),
  style: _propTypes.default.objectOf(_propTypes.default.any),
};

const PointListItem = _react.default.memo(function (_ref) {
  let _severityMap$level;

  const { point } = _ref;

  const _useState = (0, _react.useState)(false);
  const _useState2 = _slicedToArray(_useState, 2);
  const expanded = _useState2[0];
  const setExpanded = _useState2[1]; // const classes = useStyles();

  (0, _react.useEffect)(function () {
    setTimeout(function () {
      return setExpanded(true);
    }, 10);
  }, []);
  (0, _useUpdateTrigger.useUpdateTrigger)({
    restartTrigger: point.ts,
  });

  const _useMemo = (0, _react.useMemo)(
    function () {
      let _ref2;
      let _ref3;
      let _ref4;

      const _point$ts = point.ts;
      const ts = _point$ts === void 0 ? new Date() : _point$ts;
      const _point$pl = point.pl;
      const pl = _point$pl === void 0 ? [] : _point$pl;
      const { sig } = point;

      if (
        pl.length >= 2 &&
        pl.length <= 3 &&
        pl.every(function (x) {
          return typeof x === 'string';
        })
      ) {
        return [ts].concat(_toConsumableArray(pl));
      }

      const _pl = _toArray(pl);
      const _pl$ = _pl[0];
      const obj = _pl$ === void 0 ? {} : _pl$;
      const plExt = _pl.slice(1);

      const severity =
        (obj === null || obj === void 0 ? void 0 : obj.severity) ||
        (obj === null || obj === void 0 ? void 0 : obj.level) ||
        'none';

      if (plExt === null || plExt === void 0 ? void 0 : plExt.length) {
        return [ts, severity, 'pl', (0, _uiUtils.dataToText)(point.pl)];
      }

      const title =
        (_ref2 =
          (_ref3 =
            (_ref4 =
              sig !== null && sig !== void 0
                ? sig
                : obj === null || obj === void 0
                ? void 0
                : obj.signal) !== null && _ref4 !== void 0
              ? _ref4
              : obj === null || obj === void 0
              ? void 0
              : obj.title) !== null && _ref3 !== void 0
            ? _ref3
            : obj === null || obj === void 0
            ? void 0
            : obj.label) !== null && _ref2 !== void 0
          ? _ref2
          : (0, _uiUtils.dataToText)(pl[0]);
      const text =
        (obj === null || obj === void 0 ? void 0 : obj.text) ||
        (obj === null || obj === void 0 ? void 0 : obj.body) ||
        (obj === null || obj === void 0 ? void 0 : obj.message) ||
        (obj === null || obj === void 0 ? void 0 : obj.msg);
      return [ts, severity, title, text];
    },
    [point],
  );
  const _useMemo2 = _slicedToArray(_useMemo, 4);
  const time = _useMemo2[0];
  const level = _useMemo2[1];
  const label = _useMemo2[2];
  const body = _useMemo2[3]; // const { signal = 'Unknown', severity = 'none' } = pl[0];
  // const iConf = severityMap[severity] || severityMap.none;

  return /* #__PURE__ */ _react.default.createElement(
    _Collapse.default,
    {
      in: expanded,
    },
    /* #__PURE__ */ _react.default.createElement(
      _ListItem.default,
      {
        alignItems: 'flex-start',
      },
      /* #__PURE__ */ _react.default.createElement(
        _ListItemAvatar.default,
        null,
        /* #__PURE__ */ _react.default.createElement(_FlexIcon.FlexIcon, {
          icon:
            (_severityMap$level = _dmUtils.severityMap[level]) === null ||
            _severityMap$level === void 0
              ? void 0
              : _severityMap$level.icon,
          color: level,
        }),
      ),
      /* #__PURE__ */ _react.default.createElement(_ListItemText.default, {
        primary: /* #__PURE__ */ _react.default.createElement(
          _Typography.default,
          {
            variant: 'subtitle1',
          },
          label,
        ),
        secondary: /* #__PURE__ */ _react.default.createElement(
          _react.default.Fragment,
          null,
          /* #__PURE__ */ _react.default.createElement(
            _Typography.default,
            {
              variant: 'body1',
              color: 'textPrimary',
            },
            body,
          ),
          /* #__PURE__ */ _react.default.createElement(_Caption.Caption, {
            label: (0, _fp.formatDistance)(new Date(), time),
          }),
        ),
      }),
    ),
    /* #__PURE__ */ _react.default.createElement(_Divider.default, {
      component: 'li',
    }),
  );
});

exports.PointListItem = PointListItem;
PointListItem.propTypes = {
  point: _propTypes.default.objectOf(_propTypes.default.any).isRequired,
};
const defaultPoints = [];

const PointList = function PointList(_ref5) {
  const { style } = _ref5;
  const _ref5$points = _ref5.points;
  const points = _ref5$points === void 0 ? defaultPoints : _ref5$points;
  const { point } = _ref5;
  const classes = useStyles();

  const _useState3 = (0, _react.useState)(points);
  const _useState4 = _slicedToArray(_useState3, 2);
  const msgs = _useState4[0];
  const setMsgs = _useState4[1];

  (0, _react.useEffect)(
    function () {
      if ((0, _transforms.nilOrEmpty)(points)) return;
      setMsgs(points);
    },
    [points],
  );
  (0, _react.useEffect)(
    function () {
      if ((0, _transforms.nilOrEmpty)(point)) return;
      setMsgs(function (prevMsgs) {
        return [].concat(_toConsumableArray(prevMsgs), [point]);
      });
    },
    [point],
  ); // console.log('PointList', points);
  // <Box css={style} className={classes.wrapper}>

  return /* #__PURE__ */ _react.default.createElement(
    _List.default,
    {
      className: classes.wrapper,
      style,
    },
    /* #__PURE__ */ _react.default.createElement(_Divider.default, {
      component: 'li',
    }),
    R.compose(
      R.map(function (msg) {
        return /* #__PURE__ */ _react.default.createElement(PointListItem, {
          point: msg,
          key: JSON.stringify(msg),
        });
      }),
      R.reverse,
      R.when(function (m) {
        return !Array.isArray(m);
      }, R.of),
    )(msgs),
  );
};

exports.PointList = PointList;
PointList.propTypes = propTypes;
